/* SPDX-License-Identifier: LGPL-2.1-or-later */
/*
 * Copyright (C) 2020, Google Inc.
 *
 * vimc_ipa_proxy.h - Image Processing Algorithm proxy for vimc
 *
 * This file is auto-generated. Do not edit.
 */

#ifndef __LIBCAMERA_INTERNAL_IPA_PROXY_VIMC_H__
#define __LIBCAMERA_INTERNAL_IPA_PROXY_VIMC_H__

#include <libcamera/ipa/ipa_interface.h>
#include <libcamera/ipa/vimc_ipa_interface.h>

#include <libcamera/base/thread.h>

#include "libcamera/internal/control_serializer.h"
#include "libcamera/internal/ipa_proxy.h"
#include "libcamera/internal/ipc_pipe.h"
#include "libcamera/internal/ipc_pipe_unixsocket.h"
#include "libcamera/internal/ipc_unixsocket.h"

namespace libcamera {

namespace ipa {

namespace vimc {


class IPAProxyVimc : public IPAProxy, public IPAVimcInterface, public Object
{
public:
	IPAProxyVimc(IPAModule *ipam, bool isolate);
	~IPAProxyVimc();


        int32_t init(
        	const IPASettings &settings) override;

        int32_t start() override;

        void stop() override;

	Signal<uint32_t> dummyEvent;


private:
	void recvMessage(const IPCMessage &data);


        int32_t initThread(
        	const IPASettings &settings);
        int32_t initIPC(
        	const IPASettings &settings);

        int32_t startThread();
        int32_t startIPC();

        void stopThread();
        void stopIPC();


        void dummyEventThread(
        	const uint32_t val);
	void dummyEventIPC(
		std::vector<uint8_t>::const_iterator data,
		size_t dataSize,
		const std::vector<int32_t> &fds);


	/* Helper class to invoke async functions in another thread. */
	class ThreadProxy : public Object
	{
	public:
		void setIPA(IPAVimcInterface *ipa)
		{
			ipa_ = ipa;
		}

		void stop()
		{
			ipa_->stop();
		}

		int32_t start()
		{
			return ipa_->start();
		}

	private:
		IPAVimcInterface *ipa_;
	};

	Thread thread_;
	ThreadProxy proxy_;
	std::unique_ptr<IPAVimcInterface> ipa_;

	const bool isolate_;

	std::unique_ptr<IPCPipeUnixSocket> ipc_;

	ControlSerializer controlSerializer_;


	uint32_t seq_;
};

} /* namespace vimc */

} /* namespace ipa */

} /* namespace libcamera */

#endif /* __LIBCAMERA_INTERNAL_IPA_PROXY_VIMC_H__ */